;; ---- 3 Colors Example ----

(require (file "/home/pradella/docs/2d/satts/satts.scm"))

(define *gamma* '(r g b _))
(set-gamma! *gamma*)

(set-tiles!

  (tiles-not-in
    (union
      '(((_ r)
	 (r _))
	((_ g)
	 (g _))
	((_ b)
	 (b _))
	((r _)
	 (_ r))
	((g _)
	 (_ g))
	((b _)
	 (_ b))) 

      (tiling-ec
	(lambda (i j 
		 k l)
	  (or 
	    (and (equal? i '_) (equal? j '_))
	    (and (equal? k '_) (equal? l '_))
	    (and (equal? i '_) (equal? k '_))
	    (and (equal? j '_) (equal? l '_))))
	*gamma*)

      (tiling-ec
	(lambda (i j 
		 k l)
	  (or 
	    (and (member i '(r g b)) (member j '(r g b)) (not (equal? i j)))
	    (and (member k '(r g b)) (member l '(r g b)) (not (equal? k l)))
	    (and (member i '(r g b)) (member k '(r g b)) (not (equal? i k)))
	    (and (member j '(r g b)) (member l '(r g b)) (not (equal? j l)))))
	*gamma*))
    *gamma*))

(set-inverse-pi!
  '((_   _)
    (o   r g b))
  )

(define p
  '(($ $ $ $ $ $ $ $ $ $)
    ($ o o o o _ o o o $)
    ($ o o o _ o o o o $)
    ($ o o _ o _ o o o $)
    ($ o _ o o o _ o _ $)
    ($ _ o _ o _ o _ o $)
    ($ o o o _ o o o o $)
    ($ o o o o _ o o o $)
    ($ o o o _ o o o o $)
    ($ $ $ $ $ $ $ $ $ $)
    ))


(toggle-dump-tex!) ; I want the .tex table
(please-parse-it p)


