;; ---- Example ----

(require (lib "42.ss" "srfi")
	(file "/home/pradella/docs/2d/satts/satts.scm"))


(define *gamma* '(r g b _))

(define *tiles*
  (intersection
    (tiles-not-in
      '(((_ r)
	 (r _))
	((_ g)
	 (g _))
	((_ b)
	 (b _))
	((r _)
	 (_ r))
	((g _)
	 (_ g))
	((b _)
	 (_ b))
	) *gamma*)
    (tiling-ec
      (lambda (i j k l)
	(not
	  (or 
	    (and (member i '(r g b)) (member j '(r g b)) (not (eq? i j)))
	    (and (member k '(r g b)) (member l '(r g b)) (not (eq? k l)))
	    (and (member i '(r g b)) (member k '(r g b)) (not (eq? i k)))
	    (and (member j '(r g b)) (member l '(r g b)) (not (eq? j l)))
	    (and (eq? i '_) (eq? j '_))
	    (and (eq? k '_) (eq? l '_))
	    (and (eq? i '_) (eq? k '_))
	    (and (eq? j '_) (eq? l '_)))))
      *gamma*)))


(define *inverse-pi*
  '((_   _)
    (o   r g b))
  )

	(define (randomic side char1 char2)
	  (append
	    (list (list-ec (: i (+ 2 side)) '$))
	    (list-ec (: j side)
			 (append '($)
				 (list-ec (: k side)
					  (:let char #f)
					  (begin 
					    (if (= 0 (random 2))
					      (set! char char1)
					      (set! char char2)))
					  char)
				 '($)))
	    (list (list-ec (: l (+ 2 side)) '$))))

	(define (squares side char1 char2)
	  (append
	    (list (list-ec (: i (+ 2 side)) '$))
	    (list-ec (: j side)
			 (append '($)
				 (list-ec (: k side)
					  (:let char #f)
					  (begin 
					    (if (and (= 1 (remainder j 2))
						     (>= k j))
					      (set! char char1)
					      (set! char char2)))
					  char)
				 '($)))
	    (list (list-ec (: l (+ 2 side)) '$))))

;(display (randomic 20 '_ 'o))


(parse-it *tiles* *gamma* *inverse-pi* (randomic 100 '_ 'o))

(exit)

(for-each 
  (lambda (size)
    (newline)
    (display "going for ")
    (display size)
    (newline)
    (system "rm -f out.*")
    (parse-it *tiles* *gamma* *inverse-pi* (big-picture-of size 'o))
    (system "cat enter; ls -l out.*"))
  '(50 60 70 80 90 100 110 120))
